<?php

class PerchNewsfeed_Posts extends PerchAPI_Factory
{
    protected $table     = 'newsfeed';
	protected $pk        = 'postID';
	protected $singular_classname = 'PerchNewsfeed_Post';
	
	protected $default_sort_column = 'postDateTime';
    protected $created_date_column = 'postDateTime';
	
    
    /**
     * update the feed.
     */
	public function update_feed() 
	{
		if(function_exists('curl_init')) {
			$url = 'http://grabaperch.com/json/news';
			PerchUtil::debug($url);
			
			$new_posts = 0;

			$ch 	= curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_TIMEOUT, 10);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
			$json = curl_exec($ch);
			
			curl_close($ch);
			
			if ($json) {
				$data = PerchUtil::json_safe_decode($json,true);
				
				//get a list of existing news items urls for deduping.
				$a = $this->get_urls();
				
				
				for($i=0;$i<sizeOf($data['items']);$i++){
					$insert_array = array();
					$insert_array['postTitle'] = $data['items'][$i]['title'];
					$insert_array['postBody'] = $data['items'][$i]['body'];
					$insert_array['postDateTime'] = $data['items'][$i]['date'];
					$insert_array['postURL'] = $data['items'][$i]['link'];
					
					if(in_array($data['items'][$i]['link'],$a)) {
						//update
						$this->db->update($this->table,$insert_array, 'postURL',$data['items'][$i]['link'],$a);
						
						$a = array_diff($a, array($data['items'][$i]['link']));
					}else{
						//insert
						$this->db->insert($this->table,$insert_array);
						$new_posts++;
					}
				}
				
				if(PerchUtil::count($a)>0) {
					for($i=0;$i<sizeOf($a);$i++){
						$this->db->delete($this->table,'postURL',$a[$i]);
					}
				}
				
				
			}

			return $new_posts;
		}
			
		return false;
	}
    
	/*
	 * get a list of urls in the db already.
	 */
	public function get_urls() {
		$sql = 'SELECT postURL FROM '.$this->table .' ORDER BY '.$this->default_sort_column;
		$results = $this->db->get_rows($sql);
		if(PerchUtil::count($results)>0) {
			$a = array();
			foreach($results as $row) {
				$a[] = $row['postURL'];
			}
			return $a;
		}
		return array();
	}
    
    /**
     * get the stored feed
     */
    public function all($Paging=false)
    {

        if ($Paging && $Paging->enabled()) {
            $sql = $Paging->select_sql();
        }else{
            $sql = 'SELECT';
        }

        $sql .= ' * 
                FROM '.$this->table;
                
        $sql .= ' ORDER BY '.$this->default_sort_column .' DESC';
        
        

        if ($Paging && $Paging->enabled()) {
            $sql .=  ' '.$Paging->limit_sql();
        }
        

        $results = $this->db->get_rows($sql);
        
        if ($Paging && $Paging->enabled()) {
            $Paging->set_total($this->db->get_count($Paging->total_count_sql()));
        }
              
        return $this->return_instances($results);
    }
    
    /*
     *   Get a single item by its ID
    */
    public function find($postID) {
		$sql = 'SELECT * FROM '.PERCH_DB_PREFIX.'newsfeed WHERE postID = '.$this->db->pdb($postID);
		
		$row = $this->db->get_row($sql);
		
		
		
		return $this->return_instance($row);
	}
	
}
?>