<?php
	include('PerchNewsfeed_Posts.class.php');
	include('PerchNewsfeed_Post.class.php');

    $API   = new PerchAPI(1.0, 'perch_newsfeed');
    $Lang  = $API->get('Lang');

    $Paging = $API->get('Paging');
    $Paging->set_per_page(5);

    $Feed = new PerchNewsfeed_Posts($API);
    
    $posts = $Feed->all($Paging);
    

    // Install
    if ($posts == false) {
    	$Feed->attempt_install();
    	$Feed->update_feed();
    	$posts = $Feed->all($Paging);

    }

?>
<div class="widget">
	<h2>
		<?php echo $Lang->get('Perch news'); ?>
	</h2>
	<div class="bd">
		<?php
			
			
			if (PerchUtil::count($posts)) {
				echo '<ul class="perch-newsfeed-list">';
				foreach($posts as $Post) {
					echo '<li>';
						echo '<a href="'.$Post->postURL().'" class="title">';
						echo PerchUtil::html($Post->postTitle());
						echo '</a> ';
						echo '<span class="note">'.PerchUtil::html(strftime('%d %b %Y', strtotime($Post->postDateTime()))).'</span>';
						echo '<div class="full"><a href="'.$Post->postURL().'">'.PerchUtil::html($Post->postBody()).'</a></div>';
					echo '</li>';
				}
				echo '</ul>';
			}
		?>
	</div>
	<script>
	jQuery(function($){
		$('.perch-newsfeed-list').on('click', 'a.title', function(e){
			e.preventDefault();
			$(this).parent('li').find('.full').toggle();
		}).find('.full').css('margin', '1em 0').hide();	
	});
</script>
</div>
